"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Scrollbar_1 = require("./Scrollbar");
var ScrollWrapper = /** @class */ (function (_super) {
    __extends(ScrollWrapper, _super);
    function ScrollWrapper() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ref = React.createRef();
        _this.state = { isScrollbarsShow: false };
        _this.turnScrollbarsOn = function () { return _this.setState({ isScrollbarsShow: true }); };
        _this.turnScrollbarsOff = function () { return _this.setState({ isScrollbarsShow: false }); };
        _this.onScroll = function (event) {
            _this.props.onScroll({ scrollTop: event.currentTarget.scrollTop, scrollLeft: event.currentTarget.scrollLeft }, event);
        };
        _this.onWheel = function (event) {
            var deltaX = event.deltaX, deltaY = event.deltaY;
            if (deltaX || deltaY) {
                var _a = _this.props, scrollTop = _a.scrollTop, scrollLeft = _a.scrollLeft, onScroll = _a.onScroll;
                onScroll({ scrollTop: scrollTop - deltaY, scrollLeft: scrollLeft - deltaX }, event);
            }
        };
        _this.setPosition = function () {
            if (!_this.ref.current) {
                return;
            }
            var _a = _this.props, scrollTop = _a.scrollTop, scrollLeft = _a.scrollLeft;
            _this.ref.current.scrollTop = scrollTop;
            _this.ref.current.scrollLeft = scrollLeft;
        };
        return _this;
    }
    ScrollWrapper.prototype.componentDidMount = function () { this.setPosition(); };
    ScrollWrapper.prototype.componentDidUpdate = function () { this.setPosition(); };
    ScrollWrapper.prototype.render = function () {
        var _a = this.props, width = _a.width, height = _a.height, children = _a.children, fullWidth = _a.fullWidth, fullHeight = _a.fullHeight, scrollTop = _a.scrollTop, scrollLeft = _a.scrollLeft;
        return (React.createElement("div", { role: "scroll-area", ref: this.ref, style: {
                position: 'relative',
                height: height + "px",
                width: width + "px",
                overflow: 'hidden',
            }, onScroll: this.onScroll, onFocus: this.turnScrollbarsOn, onMouseEnter: this.turnScrollbarsOn, onTouchStart: this.turnScrollbarsOn, onBlur: this.turnScrollbarsOff, onMouseLeave: this.turnScrollbarsOff, onTouchEnd: this.turnScrollbarsOff, onWheel: this.onWheel },
            React.createElement("div", { role: "scroll-content", style: {
                    height: fullHeight + "px",
                    width: fullWidth + "px",
                    position: 'relative'
                } }, children),
            width < fullWidth &&
                React.createElement(Scrollbar_1.default, { type: Scrollbar_1.ScrollbarType.Horizontal, visibleContentSize: width, fullContentSize: fullWidth, scrollPosition: scrollLeft, onScroll: this.onScroll, scrollbarSize: 1 }),
            height < fullHeight &&
                React.createElement(Scrollbar_1.default, { type: Scrollbar_1.ScrollbarType.Horizontal, visibleContentSize: height, fullContentSize: fullHeight, scrollPosition: scrollTop, onScroll: this.onScroll, scrollbarSize: 1 })));
    };
    return ScrollWrapper;
}(React.PureComponent));
exports.default = ScrollWrapper;
