"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var AutoSizer = /** @class */ (function (_super) {
    __extends(AutoSizer, _super);
    function AutoSizer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ref = React.createRef();
        _this._timeout = null;
        _this.state = { width: 0, height: 0 };
        _this._timeoutHandler = function () {
            _this._timeout = window.setTimeout(function () { return _this._getSize(); }, 1000 / 60);
        };
        _this._getSize = function () {
            var _a = _this.ref.current, _b = _a.offsetHeight, height = _b === void 0 ? 0 : _b, _c = _a.offsetWidth, width = _c === void 0 ? 0 : _c;
            if (_this.state.height !== height || _this.state.width !== width) {
                _this.setState({ width: width, height: height }, function () { return _this._timeoutHandler(); });
            }
            else {
                _this._timeoutHandler();
            }
        };
        return _this;
    }
    AutoSizer.prototype.componentDidMount = function () {
        this._getSize();
    };
    AutoSizer.prototype.componentWillUnmount = function () {
        if (this._timeout !== null) {
            clearTimeout(this._timeout);
        }
    };
    AutoSizer.prototype.render = function () {
        var _a = this.state, width = _a.width, height = _a.height;
        return (React.createElement("div", __assign({}, this.props, { ref: this.ref, style: { width: '100%', height: '100%', padding: 0, margin: 0, border: 'none' } }), !!width && !!height && this.props.children({ width: width, height: height })));
    };
    return AutoSizer;
}(React.PureComponent));
exports.default = AutoSizer;
