import * as React from 'react';
import IGridProps from "../interfaces/IGridProps";
import RangeType from '../types/RangeType';
import SizeAndPositionManager from '../managers/SizeAndPositionManager';
import RenderRangersManager, { ScrollTypeEnum } from '../managers/RenderRangersManager';
interface IGridState {
    prevProps: Partial<IGridProps>;
    renderRangesManager: RenderRangersManager;
    rowManager: SizeAndPositionManager;
    columnManager: SizeAndPositionManager;
    overscanRowCount: number;
    overscanColumnCount: number;
    scrollLeft: number;
    scrollTop: number;
    rowsRange: RangeType;
    columnsRange: RangeType;
    rowScrollType?: ScrollTypeEnum;
    columnScrollType?: ScrollTypeEnum;
}
export default class Grid extends React.PureComponent<IGridProps, IGridState> {
    static getDerivedStateFromProps(props: IGridProps, state: IGridState): Partial<IGridState>;
    constructor(props: IGridProps);
    componentDidMount(): void;
    componentDidUpdate(): void;
    onScroll: (event: React.UIEvent<Element>) => void;
    render(): JSX.Element;
}
export {};
