"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Scrollbar_1 = require("./Scrollbar");
var ScrollableArea = /** @class */ (function (_super) {
    __extends(ScrollableArea, _super);
    function ScrollableArea() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ref = React.createRef();
        _this.isScrolling = false;
        _this.deltaX = 0;
        _this.deltaY = 0;
        _this.state = { isScrollbarsShow: false };
        _this.turnScrollbarsOn = function () { return _this.setState({ isScrollbarsShow: true }); };
        _this.turnScrollbarsOff = function () { return _this.setState({ isScrollbarsShow: false }); };
        _this.onWheel = function (event) {
            var deltaX = event.deltaX, deltaY = event.deltaY;
            _this.deltaY += deltaY;
            _this.deltaX += deltaX;
            if (!_this.isScrolling) {
                _this._scroll();
            }
        };
        _this._scroll = function () {
            requestAnimationFrame(function () {
                if (_this.deltaY || _this.deltaX) {
                    var _a = _this.props, height = _a.height, fullHeight = _a.fullHeight, width = _a.width, fullWidth = _a.fullWidth, scrollTop = _a.scrollTop, scrollLeft = _a.scrollLeft, onScroll = _a.onScroll;
                    if (fullHeight > height) {
                        scrollTop = Math.min(Math.max(scrollTop + _this.deltaY, 0), fullHeight - height - 1);
                    }
                    if (fullWidth > width) {
                        scrollLeft = Math.min(Math.max(scrollLeft + _this.deltaX, 0), fullWidth - width - 1);
                    }
                    _this.deltaY = _this.deltaX = 0;
                    onScroll({ scrollTop: scrollTop, scrollLeft: scrollLeft });
                }
                _this.isScrolling = false;
            });
        };
        return _this;
    }
    ScrollableArea.prototype.render = function () {
        var _a = this.props, width = _a.width, height = _a.height, children = _a.children, fullWidth = _a.fullWidth, fullHeight = _a.fullHeight, scrollTop = _a.scrollTop, scrollLeft = _a.scrollLeft, onScroll = _a.onScroll;
        return (React.createElement("div", { role: "scroll-area", ref: this.ref, style: {
                position: 'relative',
                height: height + "px",
                width: width + "px",
                overflow: 'hidden',
            }, onFocus: this.turnScrollbarsOn, onTouchStart: this.turnScrollbarsOn, onBlur: this.turnScrollbarsOff, onTouchEnd: this.turnScrollbarsOff, onWheel: this.onWheel },
            fullWidth && fullHeight && (React.createElement("div", { role: "scroll-content", style: {
                    height: fullHeight + "px",
                    width: fullWidth + "px",
                    position: 'absolute',
                    top: -scrollTop + "px",
                    left: -scrollLeft + "px",
                } }, children)),
            fullWidth && width < fullWidth &&
                React.createElement(Scrollbar_1.default, { type: Scrollbar_1.ScrollbarType.Horizontal, visibleContentSize: width, fullContentSize: fullWidth, scrollPosition: scrollLeft, onScroll: onScroll, scrollbarSize: 1 }),
            fullHeight && height < fullHeight &&
                React.createElement(Scrollbar_1.default, { type: Scrollbar_1.ScrollbarType.Vertical, visibleContentSize: height, fullContentSize: fullHeight, scrollPosition: scrollTop, onScroll: onScroll, scrollbarSize: 1 })));
    };
    return ScrollableArea;
}(React.PureComponent));
exports.default = ScrollableArea;
