"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ScrollbarType;
(function (ScrollbarType) {
    ScrollbarType[ScrollbarType["Vertical"] = 0] = "Vertical";
    ScrollbarType[ScrollbarType["Horizontal"] = 1] = "Horizontal";
})(ScrollbarType = exports.ScrollbarType || (exports.ScrollbarType = {}));
var getScrollbarWrapperStyle = function (_a) {
    var type = _a.type, _b = _a.scrollbarSize, scrollbarSize = _b === void 0 ? 10 : _b, visibleContentSize = _a.visibleContentSize;
    var style = {
        position: 'absolute',
        transition: (type === ScrollbarType.Horizontal ? 'height' : 'widht') + " .3s"
    };
    if (type === ScrollbarType.Horizontal) {
        style.left = 0;
        style.bottom = 3;
        style.width = visibleContentSize + "px";
        style.height = scrollbarSize + "px";
    }
    if (type === ScrollbarType.Vertical) {
        style.right = 3;
        style.top = 0;
        style.height = visibleContentSize + "px";
        style.width = scrollbarSize + "px";
    }
    return style;
};
var getScrollbarStyle = function (_a) {
    var type = _a.type, visibleContentSize = _a.visibleContentSize, fullContentSize = _a.fullContentSize, scrollPosition = _a.scrollPosition, _b = _a.scrollbarSize, scrollbarSize = _b === void 0 ? 10 : _b, _c = _a.scrollbarColor, scrollbarColor = _c === void 0 ? '#aaa' : _c;
    var isHorizontal = type === ScrollbarType.Horizontal;
    var size = Math.max(Math.floor(visibleContentSize * (visibleContentSize / fullContentSize)), scrollbarSize);
    var position = Math.min(visibleContentSize - size, Math.floor((scrollPosition / fullContentSize) * visibleContentSize));
    return {
        position: 'absolute',
        borderRadius: scrollbarSize / 2 + "px",
        backgroundColor: scrollbarColor,
        height: isHorizontal ? '100%' : size + "px",
        top: isHorizontal ? 0 : position + "px",
        left: isHorizontal ? position + "px" : 0,
        width: isHorizontal ? size + "px" : '100%',
    };
};
var Scrollbar = /** @class */ (function (_super) {
    __extends(Scrollbar, _super);
    function Scrollbar() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Scrollbar.prototype.render = function () {
        return (React.createElement("div", { role: "scrollbar-wrapper", style: getScrollbarWrapperStyle(this.props) },
            React.createElement("div", { role: "scrollbar", style: getScrollbarStyle(this.props) })));
    };
    return Scrollbar;
}(React.PureComponent));
exports.default = Scrollbar;
